# -*- coding: utf-8 -*-

#  Copyright © 2016  B. Clausius <barcc@gmx.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.


modules = {}

def call(modulename, func, *args):
    from . import common
    #print(__name__, 'call', modulename, func, args)
    if modulename in modules:
        module = modules[modulename]
    else:
        module = common.import_module(__name__+'.'+modulename)
        modules[modulename] = module
    return common.call(module, func, args)
    
def reload(modulename):
    from . import common
    print(__name__, 'reload common')
    common = common.reload(common)
    if modulename in modules:
        print(__name__, 'reload', modulename)
        modules[modulename] = common.reload(modules[modulename])
    
    
